package fishrungames.bashgid.core;

import java.util.ArrayList;


import fishrungames.bashgid.MainActivity;
import fishrungames.bashgid.core.AlbumManager.AlbumFullData;
import fishrungames.bashgid.core.AlbumManager.AlbumRecordData;
import fishrungames.bashgid.core.PhotoManager.PhotoRecordData;


public class ChannelManager
{
	
	public static class ChannelRecordData
	{
		public String name;
		public String title;
		public String description;
		public int hidden;
		
		
		public ChannelRecordData(String name, String title, String description, int hidden)
		{
			this.name = name;
			this.title = title;
			this.description = description;
			this.hidden = hidden;
		}
		
		public ChannelRecordData(ChannelRecordData copyFrom)
		{
			this.name = copyFrom.name;
			this.title = copyFrom.title;
			this.description = copyFrom.description;
			this.hidden = copyFrom.hidden;
		}
	}
	
	public static class ChannelFullData extends ChannelRecordData
	{
		public ArrayList<VideoManager.VideoRecordData> videoRecordArr;
		
		public ChannelFullData(ChannelRecordData recordData)
		{
			super(recordData);
			this.videoRecordArr = new ArrayList<VideoManager.VideoRecordData>();
		}
	}
	
	
	public static class ChannelRecord extends ChannelRecordData
	{
		public int id;
		
		public ChannelRecord(int id, String name, String title, String description, int hidden)
		{
			super(name, title, description, hidden);
			this.id = id;
		}
	}
	
	public static ChannelFullData CreateEmptyChannel()
	{
		ChannelFullData result = new ChannelFullData(new ChannelRecordData("", "", "", 0));
		
		return result;
	}
	
	/*
	
	public static void DownloadAndAddPhoto(PhotoRecordData recordData)
	{
		MainActivity.getInstance().DownloadImage(recordData.imageUrl, recordData.imageHash);
		
		MainActivity.getInstance().photoDataSource.AddOrReplacePhoto(recordData);
	}
	
	public static void AddExistingPhotoToAlbum(String imageUrl, String albumName)
	{
		if (!MainActivity.getInstance().albumDataSource.IsAlbumAlreadyExist(albumName))
		{
			MainActivity.getInstance().albumDataSource.CreateNewAlbum(new AlbumRecordData(albumName, albumName, ""));
		}
		
		MainActivity.getInstance().albumDataSource.AddPhotoToAlbum(imageUrl, albumName);
		
	}
	
	public static void DownloadAndAddPhotoToAlbum(PhotoRecordData recordData, String albumName)
	{
		DownloadAndAddPhoto(recordData);
		
		AddExistingPhotoToAlbum(recordData.imageUrl, albumName);
		
	}
	*/

	
	
}
